-- sofa character state machine
beginStateMachine()
	
	onEnter(function(msg)
		printSOInfo(this, "onEnter", true)
		
	end )
	
	onExit(function(msg)
		printSOInfo(this, "onExit", true)

	end )
	
	onReturn(function(msg)
		printSOInfo(this, "onReturn", true)
	end )
	
	
	state("show")
	
		onEnter(function(msg)
			printSOInfo(this, "onEnter")
			startAnimation(genderize(getParent(), "ShowClothing"))
			
			
			local showClothes = getParent().startActivity("showClothes", get("partner").getParent());
			local length, scale = getActivityLength(showClothes);
		
			sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			sendDelayedMsgThis("complete", length);
		end )
		
		onMsg("complete", function(msg)
			cancelAndExit();
		end )

		onMsg("testCancel", function(msg)
			if testCancel() then
				finishAndExit();
			else
				sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			end
		end )
		
		onExit(function(msg)
			printSOInfo(this, "onExit")
		end )
		
		onMsg("end", function(msg)
			if testCancel() then
				finishAndExit();
			else
				startAnimation(genderize(getParent(), "ShowClothing"))
			end
		end )

	state("tdance")
	
		onEnter(function(msg)
			printSOInfo(this, "onEnter")
			startAnimation(genderize2(getParent(), "Dance") .. "Loop" .. math.random(1,10), false, dspeed, 0.3);
			
			
			local twoDance = getParent().startActivity("twoDancing", get("partner").getParent());
			local length, scale = getActivityLength(twoDance);
		
			sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			sendDelayedMsgThis("complete", length);
		end )
		
		onMsg("complete", function(msg)
			cancelAndExit();
		end )

		onMsg("testCancel", function(msg)
			if testCancel() then
				finishAndExit();
			else
				sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			end
		end )
		
		onExit(function(msg)
			printSOInfo(this, "onExit")
		end )
		
		onMsg("end", function(msg)
			if testCancel() then
				finishAndExit();
			else
				startAnimation(genderize2(getParent(), "Dance") .. "Loop" .. math.random(1,10), false, dspeed, 0.3);
			end
		end )


	state("watch")
	
		onEnter(function(msg)
			printSOInfo(this, "onEnter")
			startAnimation("EmoNewObjectBigElaine", rollDice(0.5))
			
			sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			sendMsgThis("startLoop")
		end )
		
		onExit(function(msg)
			printSOInfo(this, "onExit")
		end )
		
		onMsg("testCancel", function(msg)
			if testCancel() then
				finishAndExit();
			else
				sendDelayedMsgThis("testCancel", CANCEL_POLLING_INTERVAL);
			end
		end )
				
		onMsg("startLoop", function(msg)
			startAnimation("EmoNewObjectBigElaine", rollDice(0.5), 1.0, 1);
		end )

		onMsg("end", function(msg)
			if testCancel() then
				finishAndExit();
			else
				sendMsgThis("startLoop")
			end
		end )

		
		
	
endStateMachine()